'opds.bas by df6nm
'$ lang: "qb"

v$ = "2h6"

'yy-mm-dd
'17-01-17 2h6 variable threshold, check against partial correlation with recent decodes, pattern *.txt, removed unused FFT code
'14-02-12 2h5c FreeBasic: locate space$(80) corrected, lon=-90!, cleanup.bat delete warning 2>nul
'14-02-11 2h5b FreeBasic version: arrays pmaxs!().., call1$, no asm FFT
'13-06-01 2h5  bottom-to-top output
'13-06-01 2h4d improved snr calculation, 5dB, opspeed!, deldirdone and snr debug options
'13-05-31 2h4d daysinmonth fixed, default loran off, 15 dB, headline
'13-05-23 2h4c q to quit, partly fixed midnight, no partial decodes on same freq
'13-03-16 2h4a bugfix: copy fftfile.txt
'13-03-15 2h4 show date, min. datafile len, bytesleft, timetol!, spotdelay!
'13-03-09 2h3 bugfixes: lcase thresholddb, dBOpoffset, pn!=0, sampletime!
'13-03-07 2h2 reading opds.ini
'13-03-07 2h1b reduce sensitivity if peaks$ gets too long
'13-03-05 2h1a qth neot, lorantol off, keep dirdone
'13-03-03 2h1 asm fixed (run/compile with qb.qlb: "qb.exe opds1h1.bas /l")
'13-02-28 2h overlap, qthloc
'13-02-28 2g6a thr_c 14.5dB, 8s time tolerance for repeat
'13-02-26 2g6 time sorted output
'         5i towards assembler fft usong qb /l qb.qlb ... crashes
'13-02-20 5g,h fixed data file name, sort fixed
'13-02-20 5f merge e and ex
'13-02-19 5ex dto with autocopy, thresholds back up, 23h, bw! output
'13-02-13 5e 1mHz
'13-02-11 5c,d snr calibration tests -> dBop 4 dB too high, pmaxp2! fixed
'13-02-03 2g5a,b removing duplicate peaks, pmaxp from search
'13-01-31 2g5 twin smoothing peak search with bandw estimate
'13-01-29 2g4 towards adaptive autofocus width
'13-01-29 2g3 phase twist
'13-01-28 2g2 fft autofocus
'13-01-25 2f,2g auto copy from \\white\spectrum
'13-01-14 2e  multiple files
'13-01-10 2d  correct fftx input order +n
'13-01-07 2c ignore Loran lines
'13-01-03 2b nmx 1024, fftbin buffering, peak of real part of correlation
'13-01-02 2a using SpecLab FFT
'12-12-08 1g5: rn7t, c2=0
'         1g3: includes chirp
'12-11-26 1g2 valid hits marked by *
'12-11-22 1g1 towards hitlist
'12-11-22 1g thresholds +2dB, detect both coherent and incoherent
'12-11-21 1f towards streaming buffers
'12-11-14 1e1 wide autofocus for incoherent vo1na
'12-11-14 1e autofocus
'12-11-14 1d peak search vs smoothed baseline, multiple peaks
'12-09-04 1b smallfft dec=4
'12-08-29 opds1 towards opera / qrss correlation detection

'processing scheme:
'prepare buffers, callsign list
'loop:
' get new FFT data from SpecLab
' peak search
' if > SNR threshold add to peaklist
' for each peak
'  autofocus
'  subarray
'  shift to f=0
'  for each callsign
'   expand callsign, FFT
'   multiply spectra
'   IFFT
'   peak search
'   if > corr threshold add to cslist
'  find winner (and 2nd) in cslist
'  output max (date, time, cs, snr, snrdifftosecond, freq, drift)

DEFLNG A-Z  'ncsm and ncsm% are identical because of defint
DEFINT I-N

CLS

PRINT "   ====== Opera Deep-Search Correlation Detector (opds"; v$; ") by DF6NM ======="

myqth$ = "JN59NJ"
opspeed! = 32
timewindow! = 600  'one FFT every 10 minutes  (for * mark)
spotdelay! = 29    'reported times on pskreporter show about 29 seconds after end of sequence
timetol! = 1       'symbol durations for same spot
sleeptime! = 5
sr! = 12000.385#
dec! = 48! * 512 * 1024
fc# = 137550 - .014  'SpecLab sr corrected to 120000.385 on Jan 22
verbose% = 1
asmflag% = 0
sourcepath$ = "c:\spectrum\"
pattern$ = "*.txt"  'not "0*.txt"
ffttxtfile$ = "fft.txt"
fftbinfile$ = "fft.dat"

'peak search parameters

ns1 = 5   'coherent
thresholddBc! = 6 '============
ns2 = 100  'incoherent
thresholddBi! = 3 '**************

minpeakspacing = 100 'fft bins
npm = 30  'max number of peaks

fignore# = 137610 ' 137560 'Hz   (DK7FC wspr)
ignoretol! = 0' 2 'Hz
lorantol! = 0   '.003 'Hz
lorangri$ = ""  ' "8000 7499 6731"

thresholddBcor! = 15 'dB correlation peak  ==============
thresholddBcor2! = 18 'threshold for strong signals (opds2h6)
slopesnr!=-41 'for Op32  
slopefac!=1   '1 dB/dB

outxpeak% = 0 'peak nr for debug output, 0 = none
snroffsetdB! = 0  'use -2.8 to emulate old cal -71.6
reverseoutput% = 0

inifile$ = "opds.ini"
IF LEN(COMMAND$) > 0 THEN inifile$ = COMMAND$
OPEN inifile$ FOR INPUT AS 1
WHILE NOT EOF(1)
 LINE INPUT #1, in$
 in$ = LCASE$(in$)
 eq% = INSTR(in$, ";"): IF eq% THEN in$ = LEFT$(in$, eq% - 1)      ' ;
 eq% = INSTR(in$, CHR$(39)): IF eq% THEN in$ = LEFT$(in$, eq% - 1) ' '
 eq% = INSTR(in$, "=")
 IF eq% > 0 THEN
  l$ = LEFT$(in$, eq% - 1): r$ = RTRIM$(LTRIM$(RIGHT$(in$, LEN(in$) - eq%)))

  IF l$ = "asmfft" THEN asmflag% = VAL(r$)  'ignored
  IF l$ = "verbose" THEN verbose% = VAL(r$)

  IF l$ = "myqth" THEN myqth$ = r$

  IF l$ = "sourcepath" THEN sourcepath$ = r$
  IF l$ = "pattern" THEN pattern$ = r$

  IF l$ = "opspeed" THEN opspeed! = VAL(r$)
  IF l$ = "timewindow" THEN timewindow! = VAL(r$)
  IF l$ = "spotdelay" THEN spotdelay! = VAL(r$)
  IF l$ = "timetol" THEN timetol! = VAL(r$)

  IF l$ = "sr" THEN sr! = VAL(r$)
  IF l$ = "dec" THEN dec! = VAL(r$)
  IF l$ = "fc" THEN fc# = VAL(r$)

  IF l$ = "ns1" THEN ns1 = VAL(r$)
  IF l$ = "ns2" THEN ns2 = VAL(r$)
  IF l$ = "thresholddbc" THEN thresholddBc! = VAL(r$)
  IF l$ = "thresholddbi" THEN thresholddBi! = VAL(r$)
  IF l$ = "thresholddbcor" THEN thresholddBcor! = VAL(r$)

  IF l$ = "thresholddbcor2" THEN thresholddBcor2! = VAL(r$)   '2h6
  IF l$ = "slopesnr" THEN slopesnr! = VAL(r$)                 '-41, will be scaled from Op32
  IF l$ = "slopefac" THEN slopefac! = VAL(r$)                 'dBcor/dBOp

  IF l$ = "minpeakspacing" THEN minpeakspacing = VAL(r$)
  IF l$ = "npm" THEN npm = VAL(r$)

  IF l$ = "lorantol" THEN lorantol! = VAL(r$)
  IF l$ = "lorangri" THEN lorangri$ = r$
  IF l$ = "fignore" THEN fignore# = VAL(r$)
  IF l$ = "ignoretol" THEN ignoretol! = VAL(r$)

  IF l$ = "sleeptime" THEN sleeptime! = VAL(r$)
  IF l$ = "uploadcmd" THEN uploadcmd$ = r$
 
  'snr debug options for 2h4d
  IF l$ = "emptydirdone" THEN OPEN "dirdone.txt" FOR OUTPUT AS 4: CLOSE 4
  IF l$ = "outxpeak" THEN outxpeak% = VAL(r$)
  IF l$ = "snroffsetdb" THEN snroffsetdB! = VAL(r$)
 
  IF l$ = "reverseoutput" THEN reverseoutput% = VAL(r$)

 END IF
WEND
CLOSE 1

df! = sr! / dec!
dBOpoffset! = snroffsetdB! - 68.8 - 10 * LOG(opspeed! / 32) / LOG(10)
slopesnr! = slopesnr! - 10 * LOG(opspeed! / 32) / LOG(10)  'scaling from op32

ngrim = (LEN(lorangri$) + 1) / 5
DIM gris%(ngrim) '-1)
FOR n = 0 TO ngrim - 1
 gris%(n) = VAL(MID$(lorangri$, 1 + 5 * n, 4))
NEXT n

DIM pmaxs!(npm - 1), npeak&(npm - 1), nfocls(npm - 1), nfocrs(npm - 1)

'prepffts:
lmx = 10: nmx = 1024
nmx1 = nmx - 1: nm21x = 2 * nmx - 1
DIM ax!(nm21x), wx!(nmx1), nbrx%(nmx1)
GOSUB calcwx
GOSUB calcbitrevx

DIM pbuf!(nm21x)
DIM s!(nm21x)
DIM a!(nm21x)
DIM afr!(nmx1), afi!(nmx1)
DIM tw!(nm21x), tw0!(nm21x)
pi! = 4 * ATN(1)
twfac! = .25 '0
FOR n = 0 TO nmx1
 tw0!(2 * n) = COS(twfac! * 2! * pi! * n / nmx)
 tw0!(2 * n + 1) = SIN(twfac! * 2! * pi! * n / nmx)
 tw!(2 * n) = COS(twfac! * 2! * pi! * (n / nmx - .5))
 tw!(2 * n + 1) = SIN(twfac! * 2! * pi! * (n / nmx - .5))
NEXT n

'prepare callsign list
PRINT "search list: ";
GOSUB readcallsigns
DIM calls$(ncsm% - 1)
DIM kms!(ncsm% - 1)
GOSUB prepcallsigns

endflag% = 0
WHILE NOT endflag%
 OPEN "dirdone.txt" FOR APPEND AS 4
 CLOSE 4
 SHELL "cmd /c dir " + sourcepath$ + pattern$ + " /b >dirw.txt"
 LOCATE 1, 1
 OPEN "dirw.txt" FOR INPUT AS 3
 WHILE NOT EOF(3) AND NOT endflag%
  LINE INPUT #3, direntry$
  OPEN "dirdone.txt" FOR INPUT AS 4
  filedone% = 0
  WHILE NOT EOF(4)
   LINE INPUT #4, dirdoneentry$
   IF dirdoneentry$ = direntry$ THEN filedone% = 1
  WEND
  CLOSE 4
  IF filedone% = 0 THEN
   OPEN "dirdone.txt" FOR APPEND AS 4
   PRINT #4, direntry$
   CLOSE 4
   SHELL "cmd /c copy " + sourcepath$ + direntry$ + " " + ffttxtfile$ + " /y"
   file$ = direntry$
   
   GOSUB processfile
   
   IF uploadcmd$ <> "" THEN SHELL uploadcmd$
   LOCATE 1, 1
  END IF
 WEND
 CLOSE 3
 ndirfileold = ndirfile
 IF NOT endflag% AND sleeptime! > 0 THEN SHELL "sleep " + STR$(sleeptime!)
 endflag% = endflag% OR INKEY$ = "q"
WEND
END

'___________________________________________________________________________

processfile:
for n = 1 to 4
 LOCATE n, 1:PRINT SPACE$(80)
next n
LOCATE 1, 1: PRINT "processing "; file$; " ";

OPEN ffttxtfile$ FOR INPUT AS 1
WHILE LOF(1) < 100 + 2 * nmx
 CLOSE 1
 SHELL "sleep 10"
 SHELL "cmd /c copy " + sourcepath$ + direntry$ + " " + ffttxtfile$ + " /y" '2h4a
 OPEN ffttxtfile$ FOR INPUT AS 1
WEND

INPUT #1, filedate&, filetime&, bw!, startfreq!
filetime$ = RIGHT$("00000" + LTRIM$(STR$(filetime&)), 6)
filemidhours! = VAL(LEFT$(filetime$, 2)) + VAL(MID$(filetime$, 3, 2)) / 60 + VAL(RIGHT$(filetime$, 2)) / 3600
filestarthours! = filemidhours! - .5 / df! / 3600!
fileendhours! = filemidhours! + .5 / df! / 3600!

filedate$ = RIGHT$("00000000" + LTRIM$(STR$(filedate&)), 8)
filedate$ = LEFT$(filedate$, 4) + "-" + MID$(filedate$, 5, 2) + "-" + RIGHT$(filedate$, 2)
PRINT filedate$; " ";
ophours! = filestarthours!: GOSUB hourminsecs: PRINT optime$; " to ";
ophours! = fileendhours!: GOSUB hourminsecs: PRINT optime$; " ";

'              "1201020304050607080910111201
daysinmonth$ = "3131283130313031313031303131"
day = VAL(RIGHT$(filedate$, 2))
month = VAL(MID$(filedate$, 6, 2))
year = VAL(LEFT$(filedate$, 4))
IF (year AND 3) = 0 AND ((year \ 100 <> year / 100) OR (year \ 400 = year / 400)) THEN MID$(daysinmonth$, 5, 2) = "29"
filedate1$ = filedate$
IF filestarthours! < 0 THEN
'previous day:
 day = day - 1
 IF day < 1 THEN
  month = month - 1
  IF month < 1 THEN
   month = 12
   year = year - 1
  END IF
  day = VAL(MID$(daysinmonth$, 1 + 2 * month, 2))
 END IF
 filedate1$ = RIGHT$("00000000" + LTRIM$(STR$(10000 * year + 100 * month + day)), 8)
 filedate1$ = LEFT$(filedate1$, 4) + "-" + MID$(filedate1$, 5, 2) + "-" + RIGHT$(filedate1$, 2)
END IF
day = VAL(RIGHT$(filedate$, 2))
month = VAL(MID$(filedate$, 6, 2))
year = VAL(LEFT$(filedate$, 4))
'next day:
 day = day + 1
 IF day > VAL(MID$(daysinmonth$, 1 + 2 * month, 2)) THEN
  month = month + 1
  day = 1
  IF month > 12 THEN
   month = 1
   year = year + 1
  END IF
 END IF
filedate3$ = filedate$ 'latest possible end of op sequence
IF fileendhours! + .256 * 240 * opspeed! / 3600 >= 24 THEN
 filedate3$ = RIGHT$("00000000" + LTRIM$(STR$(10000 * year + 100 * month + day)), 8)
 filedate3$ = LEFT$(filedate3$, 4) + "-" + MID$(filedate3$, 5, 2) + "-" + RIGHT$(filedate3$, 2)
END IF
filedate2$ = filedate$
IF fileendhours! >= 24 THEN filedate2$ = filedate3$

OPEN fftbinfile$ FOR OUTPUT AS 2
WHILE NOT EOF(1)
 INPUT #1, ar!, ai!
 PRINT #2, MKS$(ar!); MKS$(ai!);
WEND
CLOSE 2
IF verbose% > 1 THEN PRINT "file converted";
CLOSE 1

'smoothing for peak search (1+2*ns bins)
nwnoise = 256

thresholdhi1! = 10 ^ (thresholddBc! / 10)
thresholdlo1! = .8 * thresholdhi1!
thresholdhi2! = 10 ^ (thresholddBi! / 10)
thresholdlo2! = .8 * thresholdhi2!

OPEN fftbinfile$ FOR BINARY AS 1
nm& = LOF(1) / 8
bytesleft& = nm& * 8
SEEK #1, 1
nbufm = 1024: buf$ = SPACE$(nbufm)
nbufptr = nbufm

p2! = 0
ps! = 0
FOR n = 0 TO nm21x
 IF nbufptr >= nbufm THEN
  IF bytesleft& >= nbufm THEN
   buf$ = INPUT$(nbufm, #1): bytesleft& = bytesleft& - nbufm
  ELSE
   buf$ = INPUT$(bytesleft&, #1): bytesleft& = 0
  END IF
  nbufptr = 0
 END IF
 ar! = CVS(MID$(buf$, nbufptr + 1, 4)): ai! = CVS(MID$(buf$, nbufptr + 5, 4))
 nbufptr = nbufptr + 8
 ps! = ps! + ar! * ar! + ai! * ai!
 pbuf!(n) = ps!
NEXT n

nmx2 = nmx / 2
nmx3 = nmx * 1.5

peaks$ = ""
pmax1! = -1
pmax2! = -1
pkfound% = 0

FOR nc& = nmx / 2 TO nm& - nmx / 2

 'estimate noise l and r
 nc = nc& AND nm21x
 pnl! = pbuf!(nc - nmx2 + nwnoise AND nm21x) - pbuf!(nc - nmx2 AND nm21x)
 pnr! = pbuf!(nc + nmx2 AND nm21x) - pbuf!(nc + nmx2 - nwnoise AND nm21x)
 pn! = (pnl! + pnr!) / (2 * nwnoise)
 IF pn! > 0 THEN
  p1! = (pbuf!(nc + ns1 AND nm21x) - pbuf!(nc - ns1 AND nm21x)) / (2 * ns1)
  p2! = (pbuf!(nc + ns2 AND nm21x) - pbuf!(nc - ns2 AND nm21x)) / (2 * ns2)
  prel1! = p1! / pn! '- 1
  prel2! = p2! / pn! '- 1
 ELSE
  prel1! = 0
  prel2! = 0
 END IF

 IF prel1! >= thresholdhi1! THEN
  IF prel1! > pmax1! THEN nmax1& = nc&: pmax1! = prel1!: pn1! = pn!
 END IF
 IF pmax1! > 0 THEN
  IF prel1! < thresholdlo1! THEN pkfound% = 1: pmaxp! = pmax1!: pmax1! = -1
 END IF
 IF prel2! >= thresholdhi2! THEN
  IF prel2! > pmax2! THEN nmax2& = nc&: pmax2! = prel2!: pn2! = pn!    'pmax2! forgotten till 2g5c
 END IF
 IF pmax2! > 0 THEN
  IF prel2! < thresholdlo2! THEN pkfound% = 2: pmaxp! = pmax2!: pmax2! = -1
 END IF

 IF pkfound% > 0 THEN
  IF pkfound% = 1 THEN
   nwsearch = 5: nmax& = nmax1&:  pn! = pn1!: thr! = thresholdhi1!
  ELSE
   nwsearch = 50: nmax& = nmax2&: pn! = pn2!: : thr! = thresholdhi2!
  END IF
  'estimate bandwidth:
  nwmaxhw = 250
  nmax = nmax& AND nm21x
  p1m! = 0: n1m = 0
  p5m! = 0: n5m = 0
  p20m! = 0: n20m = 0
  FOR n = nmax - nwsearch TO nmax + nwsearch
   p1! = pbuf!(n + 1 AND nm21x) - pbuf!(n - 1 AND nm21x)
   p5! = pbuf!(n + 5 AND nm21x) - pbuf!(n - 5 AND nm21x)
   p20! = pbuf!(n + 20 AND nm21x) - pbuf!(n - 20 AND nm21x)
   IF p1! > p1m! THEN p1m! = p1!: n1m = n
   IF p5! > p5m! THEN p5m! = p5!: n5m = n
   IF p20! > p20m! THEN p20m! = p20!: n20m = n
  NEXT n
  IF (p1m! / 2 - pn!) > 2 * (p5m! / 10 - pn!) THEN
   n520 = 1: pmax! = p1m! / 2: n520m = n1m
  ELSE
   IF (p5m! / 10 - pn!) > 2 * (p20m! / 40 - pn!) THEN
    n520 = 5: pmax! = p5m! / 10: n520m = n5m
   ELSE
    n520 = 20: pmax! = p20m! / 40: n520m = n20m
   END IF
  END IF
  pthr! = (.1 * (pmax! - pn!) + pn!) * 2 * n520  '-10dB signal half widths
  nfocl = n520m - nwmaxhw
  FOR n = n520m TO n520m - nwmaxhw STEP -1
   p! = pbuf!(n + n520 AND nm21x) - pbuf!(n - n520 AND nm21x)
   IF p! < pthr! THEN nfocl = n: n = n520m - nwmaxhw
  NEXT n
  nfocr = n520m + nwmaxhw
  FOR n = n520m TO n520m + nwmaxhw
   p! = pbuf!(n + n520 AND nm21x) - pbuf!(n - n520 AND nm21x)
   IF p! < pthr! THEN nfocr = n: n = n520m + nwmaxhw
  NEXT n
  nmaxc& = nmax& - nmax + n520m
  nfocl = nfocl - n520m: nfocr = nfocr - n520m
  'dB above threshold in original peak search
  peak$ = MKL$(nmaxc&) + MKS$(pmaxp! / thr!) + MKI$(nfocl) + MKI$(nfocr)
  'sort into monotonous order:
  nlen = LEN(peaks$) / 12
  nsort = 0
  FOR n = 0 TO nlen - 1
   nfold& = CVL(MID$(peaks$, (nlen - n - 1) * 12 + 1, 4))
   IF nfold& < nmaxc& THEN
    nsort = n
    n = nlen - 1
   END IF
  NEXT n
  'peaks$ = peaks$ + peak$  'sorting disabled
  peaks$ = LEFT$(peaks$, (nlen - nsort) * 12) + peak$ + RIGHT$(peaks$, nsort * 12)
  pkfound% = 0
 END IF

 'get next sample
 IF nc& < nm& - nmx3 THEN
  IF nbufptr >= nbufm THEN buf$ = INPUT$(nbufm, #1): nbufptr = 0
  ar! = CVS(MID$(buf$, nbufptr + 1, 4)): ai! = CVS(MID$(buf$, nbufptr + 5, 4))
  nbufptr = nbufptr + 8
  ps! = ps! + ar! * ar! + ai! * ai!
  pbuf!((nc + nmx3) AND nm21x) = ps!
 END IF

 'reset pbuf! and ps! every 16k to avoid numerical inaccuracies
 IF nc& AND 16 * nmx - 1 = 0 THEN
  FOR n = 0 TO nm21x
   pbuf!(n) = pbuf!(n) - ps!
  NEXT n
  ps! = 0
 END IF

 IF LEN(peaks$) > 600 * 12 THEN
  'reduce sensitivity if too many peaks were found
  n = 0
  WHILE n <= LEN(peaks$) - 12
   prel! = CVS(MID$(peaks$, n + 5, 4)) / 1.25
   IF prel! > 1 THEN
    MID$(peaks$, n + 5, 4) = MKS$(prel!)
    n = n + 12
   ELSE
    peaks$ = LEFT$(peaks$, n) + RIGHT$(peaks$, LEN(peaks$) - n - 12)
   END IF
  WEND
  thresholdhi1! = 1.25 * thresholdhi1!
  thresholdlo1! = .8 * thresholdhi1!
  thresholdhi2! = 1.25 * thresholdhi2!
  thresholdlo2! = .8 * thresholdhi2!
 END IF

NEXT nc&

PRINT LEN(peaks$) / 12; ">";

FOR n = 0 TO -1 'LEN(peaks$) / 12 - 1
 np& = CVL(MID$(peaks$, 12 * n + 1, 4))
 fp! = fc# + df! * (np& - nm& / 2)
 p! = CVS(MID$(peaks$, 12 * n + 5, 4))
 dB! = 10 * LOG(p!) / LOG(10!)
 PRINT n; np&; fp!; "Hz"; dB!; "dB"
NEXT n


'remove loran lines and ignore range:
np = 0
FOR n = 0 TO LEN(peaks$) / 12 - 1
 np& = CVL(MID$(peaks$, 12 * np + 1, 4))
 fp# = fc# + df! * (np& - nm& / 2)
 IF verbose% > 2 THEN PRINT USING "######.###"; fp#;
 removeflag% = 0
 IF ABS(fp# - fignore#) < ignoretol! THEN
  removeflag% = 1
  IF verbose% > 2 THEN PRINT "< ";
 ELSE
  IF verbose% > 2 THEN PRINT "  ";
 END IF
 FOR ngri = 0 TO ngrim - 1
  gri% = gris%(ngri)
  fgri# = 50000# / gri%: hn& = fp# / fgri#: fh# = fgri# * hn&
  IF verbose% > 2 THEN PRINT USING "#### ######.###"; gri%; fh#;
  IF ABS(fp# - fh#) < lorantol! THEN
   removeflag% = 1
   IF verbose% > 2 THEN PRINT "< ";
  ELSE
    IF verbose% > 2 THEN PRINT "  ";
  END IF
 NEXT ngri
 IF removeflag% THEN
  peaks$ = LEFT$(peaks$, np * 12) + RIGHT$(peaks$, LEN(peaks$) - np * 12 - 12)
  'PRINT "loran line from GRI"; grifound%; "at"; fp#; " removed"
  IF verbose% > 2 THEN PRINT "removed"
 ELSE
  np = np + 1
  IF verbose% > 2 THEN PRINT
 END IF
NEXT n

np = 0
WHILE np < npm AND LEN(peaks$) > 0
 'find peak with highest power
 pmax! = -1: npmax& = 0
 FOR n = 0 TO LEN(peaks$) / 12 - 1
  p! = CVS(MID$(peaks$, 12 * n + 5, 4))
  IF p! > pmax! THEN
   pmax! = p!
   nmax = n
   npmax& = CVL(MID$(peaks$, 12 * n + 1, 4))
   nfocl = CVI(MID$(peaks$, 12 * n + 9, 2))
   nfocr = CVI(MID$(peaks$, 12 * n + 11, 2))
  END IF
 NEXT n
 pmaxs!(np) = pmax!
 npeak&(np) = npmax&
 nfocls(np) = nfocl
 nfocrs(np) = nfocr

 'remove this and nearby peaks from list
 n1 = nmax: n2 = nmax
 FOR n = 0 TO LEN(peaks$) / 12 - 1
  np& = CVL(MID$(peaks$, 12 * n + 1, 4))
  IF np& < npmax& - minpeakspacing THEN n1 = n + 1
  IF np& <= npmax& + minpeakspacing THEN n2 = n
 NEXT n

 'remove n1...n2, retain 0...n1-1 and n2+1...len-1
 peaks$ = LEFT$(peaks$, 12 * n1) + RIGHT$(peaks$, LEN(peaks$) - 12 * n2 - 12)

 fp# = fc# + df! * (npmax& - nm& / 2)
 dB! = 10 * LOG(pmax!) / LOG(10!)
 IF verbose% > 1 THEN PRINT np; npmax&; fp#; "Hz"; dB!; "dB"; n1; n2; LEN(peaks$) / 12
 np = np + 1
WEND
npfound = np
PRINT npfound; "peaks found   "

'***************************

FOR np = 0 TO npfound - 1
 npeakfft& = npeak&(np)
 fpeak# = fc# + df! * (npeakfft& - nm& / 2)
 dBfpeak! = 10 * LOG(pmaxs!(np)) / LOG(10)
 bw! = df! * (nfocrs(np) - nfocls(np))
 LOCATE 2, 1
 PRINT USING "peak ## ########.###Hz ##.#dB ###mHz "; np + 1; fpeak#; dBfpeak!; bw! * 1000;
 'LOCATE , 1

 SEEK #1, 8 * (npeakfft& - nmx \ 2) + 1
 a$ = INPUT$(8 * nmx, #1)
 FOR n = 0 TO nm21x
  a!(n) = CVS(MID$(a$, 4 * n + 1, 4))   'centered on nmx/2
 NEXT n

'autofocus (time domain)
  nfocl2 = 2 * nfocls(np)  ' < 0
  nfocr2 = 2 * nfocrs(np)  ' > 0
  psum! = 0
  FOR n2 = nmx + nfocl2 TO nmx + nfocr2 + 1
   psum! = psum! + a!(n2) * a!(n2)
  NEXT n2
  prms1! = 1 / SQR(psum!)
  FOR n2 = 0 TO nm21x: ax!(n2) = 0: NEXT n2
  FOR n2 = nfocl2 TO nfocr2 + 1
   ax!(n2 AND nm21x) = a!(n2 + nmx) * prms1!
  NEXT n2
 
  GOSUB fftbasx   'IFFT autofocus range -> time domain

  FOR n2 = 0 TO nm21x: s!(n2) = ax!(n2): NEXT n2

  FOR n2 = 0 TO nm21x: ax!(n2 + nmx AND nm21x) = a!(n2): NEXT n2

  GOSUB fftbasx   'IFFT signal -> time domain
  
  'multiply in time domain
  FOR n2 = 0 TO nm21x STEP 2
   ar! = ax!(n2) * s!(n2) + ax!(n2 + 1) * s!(n2 + 1)
  'real part with twisted phase
   ax!(n2) = ar! * tw!(n2)
   ax!(n2 + 1) = -ar! * tw!(n2 + 1)
  NEXT n2
 
  GOSUB fftbasx 'FFT -> frequency domain
 
  IF np + 1 = outxpeak% THEN GOSUB outdatax
 
  scale! = 1 / nmx / nmx
  FOR n2 = 0 TO nm21x STEP 2
   s!(n2) = ax!(n2) * scale!
   s!(n2 + 1) = -ax!(n2 + 1) * scale!  'conjugate
  NEXT n2
 
'calculate carrier SNR:
 psum! = 0
 FOR n = 0 TO 2 * nmx - 1
  psum! = psum! + s!(n) * s!(n)
 NEXT n
 
 ppeakaf! = 0
 FOR n = -4 * 2 TO 4 * 2 + 1  '9 bins
  ppeakaf! = ppeakaf! + s!(n AND nm21x) * s!(n AND nm21x)
 NEXT n
 'opera: p/4 in carrier, p/8 signal in each sideband
 pnoiseaf! = (psum! - ppeakaf! * 1.95) / (nmx - 9)
 'snr! = ppeakaf! / pnoiseaf! - 9
 'empirical correction for demodulated noise from incoherent bandwidth
 bwn! = bw! * opspeed! / 32
 snr! = ppeakaf! / pnoiseaf! - 8000 * bwn!
 IF snr! > 2000 THEN
  'high snr threshold +33dB-68.8dB = -35.8dBop (pep snr 1 in 2Hz)
  'noise measured in 2*21 bins near edges of spectrum
  pnoise2! = 0
  FOR n = nmx - 30 * 2 TO nmx - 10 * 2 + 1
   pnoise2! = pnoise2! + s!(n) * s!(n)
  NEXT n
  FOR n = nmx + 10 * 2 TO nmx + 30 * 2 + 1
   pnoise2! = pnoise2! + s!(n) * s!(n)
  NEXT n
  'empirical correction of noise for carrier leakage at high snr
  pnoiseaf! = (pnoise2! - .000013 * ppeakaf! * (1 + 120 * bwn!)) / 42
  'bw-dependent fudge factor for incoherent around -30dBop (snr=2)
  pnoiseaf! = pnoiseaf! * (1 + 5 * bwn!)
  snr! = ppeakaf! / pnoiseaf! - 9
 END IF
 
 IF snr! > 0 THEN
  dBOp! = 10 * LOG(snr!) / LOG(10) + dBOpoffset!
 ELSE
  IF pnoiseaf! < 0 THEN dBOp! = 0 ELSE dBOp! = -99.9
 END IF
 
 IF outxpeak% > 0 THEN
  LOCATE 10 + np
  PRINT USING "## ######.###Hz ##.#dB ###mHz"; np + 1; fpeak#; dBfpeak!; bw! * 1000;
  PRINT psum! * nmx ^ 2; ppeakaf! * nmx ^ 2; pnoiseaf! * nmx ^ 2 * (nmx - 9); dBOp!; "*"
  PRINT SPACE$(80);
  LOCATE 2
 END IF
 
 symboltime! = opspeed! * .256
 sampletime! = 1 / df! / nmx
 'PRINT symboltime! / sampletime! 'dec ~ 4
 
 dBmax! = -1
 FOR ncs = 0 TO ncsm - 1
  FOR n = 0 TO nmx - 1
   n2 = 2 * n
   nop = n * sampletime! / symboltime!
   prot! = 0
   IF nop < 240 THEN prot! = VAL(MID$(callsop$, 240 * ncs + nop + 1, 1)) - .5
   ax!(2 * n) = prot! * tw!(2 * n)
   ax!(2 * n + 1) = prot! * -tw!(2 * n + 1)
  NEXT n
  
  GOSUB fftbasx
  
  FOR n2 = 0 TO 2 * nmx - 1 STEP 2
   ar! = s!(n2) * ax!(n2) - s!(n2 + 1) * -ax!(n2 + 1)
   ai! = s!(n2) * ax!(n2 + 1) + s!(n2 + 1) * -ax!(n2)
   ax!(n2) = ar!: ax!(n2 + 1) = ai!
  NEXT n2
  
  GOSUB fftbasx
  
  'untwist
  FOR n2 = 0 TO nm21x STEP 2
   ar! = ax!(n2) * tw0!(n2) - ax!(n2 + 1) * -tw0!(n2 + 1)
   ai! = ax!(n2 + 1) * tw0!(n2) + ax!(n2) * -tw0!(n2 + 1)
   ax!(n2) = ar!: ax!(n2 + 1) = -ai!
  NEXT n2
  
  'sort iiiirrrr
  FOR n = 0 TO nmx1
   a!(n) = ax!(2 * n + 1)
   a!(n + nmx) = ax!(2 * n)
  NEXT n
  
  'search correlation peak in time domain
  'search long real array
  psum! = 0
  apr! = 0
  FOR n = 0 TO nm21x
   ar! = a!(n): p! = ar! * ar!
   psum! = psum! + p!
   IF ar! > apr! THEN np2 = n: apr! = ar! 'real only
  NEXT n
  pmax! = apr! * apr!
  npeak = np2 - nmx
  pav! = psum! / nmx
  dBp! = 10 * LOG(pmax! / pav!) / LOG(10)
  npeakc = npeak
  hours! = npeakc * sampletime! / 3600 + filestarthours!
  IF dBp! > dBmax! THEN
   dBmax! = dBp!: ncsmax = ncs: hoursmax! = hours!: npeakcmax = npeakc
   aprmax! = apr!: apimax! = api!
  END IF
 NEXT ncs
 
 hoursmid! = hoursmax! + 120 * symboltime! / 3600
 hoursend! = hoursmax! + 240 * symboltime! / 3600
 ophours! = hoursend! + spotdelay! / 3600  'matching time from spotlist
 GOSUB hourminsecs
 IF VAL(LEFT$(optime$, 2)) < 12 THEN opdate$ = filedate3$ ELSE opdate$ = filedate1$ 'fixed opds2h4c
 
 thresholdx!= thresholddBcor! + (dBOp! - slopesnr!)*slopefac!               '2h6
 if thresholdx! < thresholddBcor! then thresholdx! = thresholddBcor!
 if thresholdx! > thresholddBcor2! then thresholdx! = thresholddBcor2!

 IF dBmax! > thresholdx! OR verbose% > 2 THEN
  'sorted output
   opduration! = .256 * opspeed! * 240 / 3600
   ov1! = .5 + (hoursmid! - filestarthours!) / opduration!
   ov2! = .5 - (hoursmid! - fileendhours!) / opduration!
   IF ov2! > ov1! THEN ov! = ov1! ELSE ov! = ov2!
   IF ov! > 1! THEN ov! = 1!
   
   '1234567891123456789212345678931234567894123456789512345678961234567897123456
   '2012-01-01 18:44:17 RN3AGC 11985km 137571.028Hz 123mHz -41.6dBOp 100% 20.4dB__
  '"   date      time   call   distance  frequency bandwidth  SNR    correlation"
   
   outline$ = SPACE$(80) '(76)
   MID$(outline$, 1, 10) = opdate$
   MID$(outline$, 12, 8) = optime$
   call1$ = LEFT$(calls$(ncsmax) + "      ", 6)
   MID$(outline$, 21, 6) = call1$
   MID$(outline$, 28, 7) = RIGHT$("    " + RTRIM$(STR$(INT(kms!(ncsmax) + .5))), 5) + "km"
   num$ = RIGHT$("        " + STR$(INT(fpeak# * 1000 + .5)), 9): num$ = LEFT$(num$, 6) + "." + RIGHT$(num$, 3)
   MID$(outline$, 36, 12) = num$ + "Hz"
   MID$(outline$, 49, 6) = RIGHT$("  " + STR$(INT(bw! * 1000 + .5)), 3) + "mHz"
   num$ = RIGHT$("   " + STR$(INT(dBOp! * 10 + .5)), 4): num$ = LEFT$(num$, 3) + "." + RIGHT$(num$, 1)
   MID$(outline$, 56, 9) = num$ + "dBOp"
   MID$(outline$, 66, 4) = RIGHT$("  " + STR$(INT(ov! * 100 + .5)), 3) + "%"
   num$ = RIGHT$("   " + STR$(INT(dBmax! * 10 + .5)), 3): num$ = LEFT$(num$, 2) + "." + RIGHT$(num$, 1)
   MID$(outline$, 71, 6) = num$ + "dB"

   num$ = RIGHT$("   " + STR$(INT(dBfpeak! * 10 + .5)), 3): num$ = LEFT$(num$, 2) + "." + RIGHT$(num$, 1)
   MID$(outline$, 77, 4) = num$  'only internally saved
   
   outlinelen% = LEN(outline$)
   numentries% = LEN(outlines$) \ LEN(outline$)
   seconds& = 3600& * VAL(LEFT$(optime$, 2)) + 60& * VAL(MID$(optime$, 4, 2)) + VAL(RIGHT$(optime$, 2))
   LOCATE 3,1 : PRINT outline$;
   outlinedone% = 0
   ninsert=-1
   FOR n = 0 TO numentries% - 1
    outlinec$ = MID$(outlines$, LEN(outlines$) - (n + 1) * outlinelen% + 1, outlinelen%)
    opdatec$ = LEFT$(outlinec$, 10)
    daysdelta = VAL(RIGHT$(opdate$, 2)) - VAL(RIGHT$(opdatec$, 2))
     IF daysdelta > 15 THEN daysdelta = -1
     IF daysdelta < -15 THEN daysdelta = 1
    optimec$ = MID$(outlinec$, 12, 8)
    dBmaxc! = VAL(MID$(outlinec$, 71, 4))
    dBfpeakc! = VAL(MID$(outlinec$, 77, 4))
    callc$ = MID$(outlinec$, 21, 6)
    secondsc& = 3600& * VAL(LEFT$(optimec$, 2)) + 60& * VAL(MID$(optimec$, 4, 2)) + VAL(RIGHT$(optimec$, 2))
    secondsdelta& = seconds& - secondsc&
    secondsdelta& = secondsdelta& + 86400 * daysdelta
    freqdelta! = VAL(MID$(outline$, 36, 10)) - VAL(MID$(outlinec$, 36, 10))
    samefreqflag% = ABS(freqdelta!) < minpeakspacing * df! AND ABS(secondsdelta&) <= 240 * .256 * opspeed! AND call1$ <> callc$
    IF (ABS(secondsdelta&) <= timetol! * .256 * opspeed! AND call1$ = callc$) OR samefreqflag% THEN 'spot already there
    'carrier snr-weighted peak qualification  (since 2h4d)
     IF dBmax! + .2 * dBfpeak! > dBmaxc! + .2 * dBfpeakc! THEN 'replace entry
      MID$(outlines$, LEN(outlines$) - (n + 1) * outlinelen% + 1, outlinelen%) = outline$
     'ELSE 'drop entry
     END IF
     ninsert=-1
     outlinedone% = 1
     n = numentries%
    ELSE
     IF secondsdelta& > 0 AND ninsert < 0 THEN ninsert=n  'remember to insert here     (opds2h6)
     IF secondsdelta& > 240 * .256 * opspeed! THEN  n = numentries% 'checked past 32 minutes
    END IF
   NEXT n
   IF ninsert >= 0 THEN
    outlines$ = LEFT$(outlines$, (numentries% - ninsert) * outlinelen%) + outline$ + RIGHT$(outlines$, ninsert * outlinelen%)
    outlinedone% = 1
   end if
   IF outlinedone% = 0 THEN outlines$ = outline$ + outlines$ 'write to beginning of list
 END IF
   
 endflag% = endflag% OR INKEY$ = "q"
 IF endflag% THEN np = npm
NEXT np

 for n = 5 to 12
  LOCATE n, 1:PRINT SPACE$(80)
 next n
 LOCATE 5, 1
 title$ = "   date      time   call   distance  frequency bandwidth  snr    correlation"
 PRINT title$
 IF outlinelen% > 0 THEN numentries% = LEN(outlines$) \ outlinelen%
 OPEN "detected.txt" FOR OUTPUT AS 4
 IF reverseoutput% THEN
  FOR n = numentries% - 1 TO 0 STEP -1
   PRINT MID$(outlines$, n * outlinelen% + 1, outlinelen% - 4)
   PRINT #4, MID$(outlines$, n * outlinelen% + 1, outlinelen% - 4)
  NEXT n
 ELSE
  FOR n = 0 TO numentries% - 1
   PRINT MID$(outlines$, n * outlinelen% + 1, outlinelen% - 4)
   PRINT #4, MID$(outlines$, n * outlinelen% + 1, outlinelen% - 4)
  NEXT n
 END IF
 LOCATE 1, 1
 CLOSE 4
 
 IF outxpeak% > 0 THEN outlines$ = ""

CLOSE 1
RETURN

'__________________________

'SNR calculation for Op32: (old)
' threshold 15dB (incl. duty cycle 50%)
' averaged 3 bins (nsmooth1) + 4.8dB > threshold +20 dB
' FFT BW 0.25 mHz = -36 dBHz = -70 dB_2.5kHz
' => -50 dB_2.5k = -54 dBOp
' min signal ~17 dB => -52 dBOp
' ~13 dB better than standard Op32 (-39 dBOp)
' SNRcarrierenergy + 6dB (50%) + 1dB (Topera/Tbuf) -70dB (Bfft/2.5kHz) - 4dB (Op scale)

hourminsecs:
 IF ophours! < 0 THEN ophours! = ophours! + 24
 IF ophours! > 24 THEN ophours! = ophours! - 24
 ophours% = INT(ophours!)
 opmins% = INT(60! * (ophours! - ophours%))
 opsecs% = INT(3600! * (ophours! - ophours%) - 60 * opmins%)
 'PRINT ophours!; ophours%; opmins%; opsecs%
 optime$ = RIGHT$("0" + LTRIM$(STR$(ophours%)), 2)
 optime$ = optime$ + ":" + RIGHT$("0" + LTRIM$(STR$(opmins%)), 2)
 optime$ = optime$ + ":" + RIGHT$("0" + LTRIM$(STR$(opsecs%)), 2)
RETURN

outdatax:
 OPEN "outx.txt" FOR OUTPUT AS 2
 FOR n = 0 TO nmx - 1
  PRINT #2, ax!(2 * n); ax!(2 * n + 1)
 NEXT n
 CLOSE 2
 RETURN

readcallsigns:
qth$ = myqth$: GOSUB qth2latlon: mylat! = lat!: mylon! = lon!
pos$ = ""

OPEN "callsloc.txt" FOR INPUT AS 1
WHILE NOT EOF(1)
 LINE INPUT #1, in$
 in$ = LTRIM$(RTRIM$(in$))
 km! = 0
 spacep = INSTR(in$, " ")
 IF spacep > 1 THEN
  qth$ = LTRIM$(MID$(in$, spacep))
  in$ = LEFT$(in$, spacep - 1)
  IF LEN(qth$) >= 6 THEN
   GOSUB qth2latlon
   GOSUB calcdist
  END IF
 END IF
 IF LEN(in$) > 0 AND LEN(in$) < 7 THEN
  pos1% = pos1% + LEN(in$)
  pos$ = pos$ + MKI$(pos1%)
  km$ = km$ + MKS$(km!)
  cs$ = cs$ + in$
 END IF
WEND
CLOSE 1
ncsm% = LEN(pos$) \ 2
RETURN

prepcallsigns:
startpos% = 0

FOR n% = 0 TO ncsm% - 1
 pos1% = CVI(MID$(pos$, 2 * n% + 1, 2))
 calls$(n%) = MID$(cs$, startpos% + 1, pos1% - startpos%)
 startpos% = pos1%
 kms!(n%) = CVS(MID$(km$, 4 * n% + 1, 4))
NEXT n%

FOR ncall% = 0 TO ncsm% - 1
 call1$ = calls$(ncall%)
 GOSUB opgen
 callsop$ = callsop$ + man$ + " "
NEXT ncall%

FOR n% = 0 TO ncsm% - 1
 PRINT calls$(n%); " ";
NEXT n%
 PRINT
RETURN

qth2latlon:
 a = ASC("A"): z = ASC("0")
 l$ = UCASE$(qth$)
 lon! = -90! + 10! * (ASC(MID$(l$, 1, 1)) - a)          '! FB 2h5c
 lon! = lon! + ASC(MID$(l$, 3, 1)) - z
 lon! = 2 * (lon! + (ASC(MID$(l$, 5, 1)) - a + .5) / 24)
 lat! = -90! + 10! * (ASC(MID$(l$, 2, 1)) - a)          '! FB 2h5c
 lat! = lat! + ASC(MID$(l$, 4, 1)) - z
 lat! = lat! + (ASC(MID$(l$, 6, 1)) - a + .5) / 24
RETURN

calcdist:
 pi! = 4 * ATN(1)
 rearth! = 6371!
 gam# = (lon! - mylon!) * pi! / 180
 a# = mylat! * pi! / 180!: b# = lat! * pi! / 180!
 cosc# = SIN(a#) * SIN(b#) + COS(a#) * COS(b#) * COS(gam#)
 sinc# = SQR(1# - cosc# * cosc#)
 cc! = ATN(sinc# / cosc#)
 IF cc! < 0 THEN cc! = cc! + pi!
 km! = cc! * rearth!
RETURN

'_________________________________________
opgen:
' OPera code GENerator
' generates Opera keying sequence originally defined by Jose Ros EA5HVK
' emulation based on protocol description by Guido PE1NNZ
'  http://rn3aus.narod.ru/opera_protocol.pdf

' implemented by DF6NM
' v1 12-07-14
' v2 12-07-16
' usage: opgen aa1aa >opera.txt

'align callsign
call1$ = UCASE$(call1$)
call1$ = "      " + call1$ + "      "
'look for last number
n1 = 0
FOR n = 1 TO LEN(call1$)
 a = ASC(MID$(call1$, n, 1))
 IF a >= ASC("0") AND a <= ASC("9") THEN n1 = n
NEXT n
IF n1 < 6 OR n1 > LEN(call1$) - 6 THEN PRINT "no number found in callsign": END
call1$ = MID$(call1$, n1 - 2, 6)

'callsign into 28 bits
c2 = 0  'was missing before 1g5
c1 = ASC(MID$(call1$, 1, 1))
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48 + 27
c = c2
c1 = ASC(MID$(call1$, 2, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 65
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48 + 26
c = c * 36 + c2
c1 = ASC(MID$(call1$, 3, 1))
c2 = 0
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48
c = c * 10 + c2
c1 = ASC(MID$(call1$, 4, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2
c1 = ASC(MID$(call1$, 5, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2
c1 = ASC(MID$(call1$, 6, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2

' ascii 01 sequence
c$ = RIGHT$(STRING$(7, "0") + HEX$(c), 7)
h$ = c$: GOSUB hextobin
cb$ = b$

'first crc
b$ = cb$: GOSUB calccrc
h$ = crc$
GOSUB hextobin

' replace zeroes by 2b and 1b, swap bytes
IF MID$(b$, 1, 8) = "00000000" THEN MID$(b$, 1, 8) = "00101011"
IF MID$(b$, 9, 8) = "00000000" THEN MID$(b$, 9, 8) = "00011011"
b$ = MID$(b$, 9, 8) + MID$(b$, 1, 8)
cb$ = cb$ + b$

'second crc
b$ = cb$: GOSUB calccrc: h$ = HEX$(crc&)
GOSUB hextobin

'append 4 zero bits and 3bits from crc
b$ = MID$(b$, 6, 3)
cb$ = "0000" + cb$ + b$

'xor with scrambling vector
h$ = "70ABF3680C8AB"
GOSUB hextobin
prn$ = RIGHT$(b$, 51)
FOR n = 1 TO 51
 x = (ASC(MID$(prn$, n, 1)) - 48) XOR (ASC(MID$(cb$, n, 1)) - 48)
 MID$(cb$, n, 1) = CHR$(48 + x)
NEXT n

'Welsh-Hadamard 3 to 7 bit
hd$ = ""
hd$ = hd$ + "0000000" + "1010101" + "0110011" + "1100110"
hd$ = hd$ + "0001111" + "1011010" + "0111100" + "1101001"

hd1$ = ""
FOR n = 0 TO 17 - 1
 a$ = MID$(cb$, 3 * n + 1, 3)
 a = 0
 FOR n1 = 1 TO 3
  a = a * 2 + ASC(MID$(a$, n1, 1)) - 48
 NEXT n1
 hd1$ = hd1$ + MID$(hd$, 1 + a * 7, 7)
NEXT n

'interleave 7x17
hd2$ = ""
FOR n = 0 TO 6
 FOR n2 = 0 TO 16
  hd2$ = hd2$ + MID$(hd1$, 1 + n2 * 7 + n, 1)
 NEXT n2
 hd2$ = hd2$ '+ " "
NEXT n

'manchester encoding, add 11, omit last bit
man$ = ""
FOR n = 1 TO 17 * 7
 IF MID$(hd2$, n, 1) = "1" THEN m1$ = "01" ELSE m1$ = "10"
 man$ = man$ + m1$
NEXT n
man$ = LEFT$("11" + man$, 239)

RETURN

hextobin:
 b$ = ""
 FOR n = 1 TO LEN(h$)
  h1 = VAL("&h" + MID$(h$, n, 1))
  FOR n2 = 1 TO 4
   b1$ = CHR$(48 + (h1 \ 8))
   b$ = b$ + b1$
   h1 = (2 * h1) AND 15
  NEXT n2
 NEXT n
RETURN

calccrc:
 'ascii 0 and 1 bytes, lsb first
 poly& = &H8005&:
 crc& = 0
 FOR nbyte = 1 TO LEN(b$)
  bb = ASC(MID$(b$, nbyte, 1))
  FOR nbit = 0 TO 7
   IF (bb AND 1) <> (crc& \ &H8000&) THEN
    crc& = (crc& + crc&) AND &HFFFF&  'shiftl
    crc& = crc& XOR poly&
   ELSE
    crc& = (crc& + crc&) AND &HFFFF&  'shiftl
   END IF
   bb = bb \ 2
  NEXT nbit
 NEXT nbyte
 'reverse CRC result
 crc1& = 0
 FOR nbit = 0 TO 15
  crc1& = 2 * crc1& + (crc& AND 1&)
  crc& = crc& \ 2
 NEXT nbit
 crc& = crc1&
 crc$ = RIGHT$("0000" + HEX$(crc&), 4)
RETURN

'_______________________________________
'FFT stuff

calcwx:
'nmx/2 warp factors
  sc! = 1
  pi! = 4 * ATN(1)
  FOR n = 0 TO nmx \ 2 - 1
   wx!(2 * n) = sc! * COS(2 * pi! * n / nmx)
   wx!(2 * n + 1) = sc! * -SIN(2 * pi! * n / nmx)
  NEXT n
 RETURN

calcbitrevx:
'bit reversal table
  FOR n = 0 TO nmx - 1
   n2 = 0: n1 = n
   FOR l = 0 TO lmx - 1
    n2 = 2 * n2 + (n1 AND 1)
    n1 = n1 \ 2
   NEXT l
   nbrx%(n) = n2
  NEXT n
 RETURN

fftbasx:
 FOR n = 0 TO nmx - 1
  n2 = nbrx%(n)
  IF n2 < n THEN SWAP ax!(2 * n), ax!(2 * n2): SWAP ax!(2 * n + 1), ax!(2 * n2 + 1)
 NEXT n

 nd = 1: nwd = nmx \ 2
 FOR l = 0 TO lmx - 1
  FOR n0 = 0 TO nmx - 1 STEP 2 * nd
   nw = 0
   FOR n1 = n0 TO n0 + nd - 1
    n2 = n1 + nd
   
    n1r = 2 * n1: n1i = n1r + 1
    n2r = 2 * n2: n2i = n2r + 1
    nwr = 2 * nw: nwi = nwr + 1

    vr! = (ax!(n2r) * wx!(nwr) - ax!(n2i) * wx!(nwi))
    vi! = (ax!(n2i) * wx!(nwr) + ax!(n2r) * wx!(nwi))
    ax!(n2r) = ax!(n1r) - vr!: ax!(n2i) = ax!(n1i) - vi!
    ax!(n1r) = ax!(n1r) + vr!: ax!(n1i) = ax!(n1i) + vi!
    nw = nw + nwd
   NEXT n1
  NEXT n0
  nd = 2 * nd
  nwd = nwd \ 2
 NEXT l
RETURN
'_______________________________________
